void drawBarGraph() {

  // spacings
  int hGap = 100;
  int vGap = 200;
  int bWidth = 4;
  int axisOffset = 5;
  int ringOffset = 100;
  
  strokeWeight(bWidth);
  strokeCap(SQUARE);

  // spacing accumulator
  int lGap = hGap;
  
  // label
  String label = "";

  for (int i = 0; i < dArray.get(0).size(); i++) {

    // reset detector
    mouseDetected = false;

    float[] sum = {
      0.0, 0.0
    };

    // for token ring viz
    float[] nyt = {
      0.0, 0.0, 0.0
    };
    float[] spl = {
      0.0, 0.0, 0.0
    };

    // for the triangles
    noSmooth();

    // curser detector
    float x1 = lGap - bWidth/2;
    float x2 = x1 + 3*bWidth + 1;
    if ( mouseX >= x1 && mouseX <= x2) {
      mouseDetected = true;
    }

    for (int j = 0; j < dArray.size(); j++) {
      // put one into bag
      Bag b = (Bag) dArray.get(j).get(i);
      if (j==0) label = b.label;
      int x, y, y0;

      // nyt
      if (j<3) {
        y0 = vGap - axisOffset;
        x  = lGap + j*bWidth;
        y  = vGap -axisOffset - b.count/4;
        nyt[j] = b.count;
      }
      // spl
      else {
        y0 = vGap + axisOffset;
        x  = lGap + (j-3)*bWidth;
        y  = vGap + axisOffset + b.count/4;
        spl[j-3] = b.count;
      }

      sum[j/3] += b.count;

      // mouse interaction with opacity
      stroke(palette[(j%3)], constrain(1.0 - ( float(abs(mouseX - x))*8/float(width)), 0.4, 1.0) );
      line(x, y0, x, y);
    }

    // draw token ring
    if ( mouseDetected ) {
      pushStyle();
      smooth();

      float prevAngle = PI;
      float r = (sum[0]+sum[1])/4; // radius side depends on the ratio
      fill(#FFFFFF, sum[0]/maxVals[0]);
      arc( width/2, height/2 + ringOffset, r, r, PI, 2*PI); // nyt
      fill(#FFFFFF, sum[1]/maxVals[1]);
      arc( width/2, height/2 + ringOffset, r, r, 0, PI); // nyt

      noFill();
      for (int k = 0; k < dArray.size()/2; k++) {
        float angle = PI * nyt[k] / sum[0];
        stroke(palette[k]);
        strokeWeight( constrain( 0.4 * r * (nyt[k]/sum[0]), 7.0, 0.4*r ));
        arc(width/2, height/2 + ringOffset, r, r, prevAngle, constrain(prevAngle + angle, PI, 2*PI));
        prevAngle += angle;
      }

      prevAngle = radians(0);
      for (int k = 0; k < dArray.size()/2; k++) {
        float angle = PI * spl[k] / sum[1];
        stroke(palette[k]);
        strokeWeight( constrain( 0.4 * r * (spl[k]/sum[1]), 7.0, 0.4*r ));
        arc(width/2, height/2 + ringOffset, r, r, prevAngle, constrain(prevAngle + angle, 0, PI));
        prevAngle += angle;
      }

      // draw a grid line
      stroke(#EEEEEE, 0.4);
      strokeWeight(1);
      line(width/2-150, height/2 + ringOffset, width/2 + 150, height/2 + ringOffset);
      
      // text (number next to the arcs)
      textFont(myFont1);  
      fill(0.3f);
      textAlign(RIGHT, BOTTOM);
      text(int(sum[0]), width/2 - 150, height/2 + ringOffset);
      textAlign(RIGHT, TOP);
      text(int(sum[1]), width/2 - 150, height/2 + ringOffset);
      
      textFont(myFont);
      fill(1.0f, 0.5f);
      textAlign(LEFT, CENTER);
      text(label, 20, vGap);
      
      popStyle();
    }


    // draw triangles on the axis
    pushStyle();
    noStroke();
    ArrayList<float[]> vertices = new ArrayList<float[]>();

    float y1 = vGap - axisOffset;
    float y2 = vGap + axisOffset;
    float[] vertNyt = {
      x1, y1, x2, y1, x1, y2
    };
    float[] vertSpl = {
      x2, y2, x2, y1, x1, y2
    };
    vertices.add(vertNyt);
    vertices.add(vertSpl);
    for (int k = 0; k < 2; k++) {
      float[] tmp = vertices.get(k);
      if (mouseDetected) {
        fill(#FF0000, sum[k]/maxVals[k]);
      }
      else {
        fill(#FFFFFF, sum[k]/maxVals[k]);
      }
      triangle(tmp[0], tmp[1], tmp[2], tmp[3], tmp[4], tmp[5]);
    }
    popStyle();
    lGap += (3*bWidth + 2);
  }
}

